Attribute VB_Name = "Module1"
Option Explicit

'////////////////////////////////////////
'//To diaplay API Error
'////////////////////////////////////////
Global Const FORMAT_MESSAGE_ALLOCATE_BUFFER = &H100
Global Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Global Const LANG_NEUTRAL = &H0
Global Const SUBLANG_DEFAULT = &H1

Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)
Public Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
'////////////////////////////////////////
'//API for AVI
'////////////////////////////////////////

Public Declare Function mmioStringToFOURCC Lib "winmm.dll" Alias "mmioStringToFOURCCA" _
        (ByVal sz As String, _
        ByVal uFlags As Long) As Long    'returns fourcc

Public Declare Function VideoForWindowsVersion Lib "msvfw32.dll" () As Long

Public Declare Function AVIFileInfo Lib "avifil32.dll" _
        (ByVal pfile As Long, _
        pfi As AVI_FILE_INFO, _
        ByVal lSize As Long) As Long    'HRESULT

Public Declare Sub AVIFileInit Lib "avifil32.dll" ()

Public Declare Function AVIFileOpen Lib "avifil32.dll" _
        (ByRef ppfile As Long, _
        ByVal szFile As String, _
        ByVal uMode As Long, _
        ByVal pclsidHandler As Long) As Long    'HRESULT

Public Declare Function AVIFileCreateStream Lib "avifil32.dll" Alias "AVIFileCreateStreamA" _
        (ByVal pfile As Long, _
        ByRef ppavi As Long, _
        ByRef psi As AVI_STREAM_INFO) As Long

Public Declare Function AVISaveOptions Lib "avifil32.dll" _
        (ByVal hWnd As Long, _
        ByVal uiFlags As Long, _
        ByVal nStreams As Long, _
        ByRef ppavi As Long, _
        ByRef ppOptions As Long) As Long    'TRUE if user pressed OK, False if cancel, or error if error

Public Declare Function AVISave Lib "avifil32.dll" Alias "AVISaveVA" (ByVal szFile As String, _
        ByVal pclsidHandler As Long, _
        ByVal lpfnCallback As Long, _
        ByVal nStreams As Long, _
        ByRef ppaviStream As Long, _
        ByRef ppCompOptions As Long) As Long

Public Declare Function AVISaveOptionsFree Lib "avifil32.dll" (ByVal nStreams As Long, _
        ByRef ppOptions As Long) As Long

Public Declare Function AVIMakeCompressedStream Lib "avifil32.dll" (ByRef ppsCompressed As Long, _
        ByVal psSource As Long, _
        ByRef lpOptions As AVI_COMPRESS_OPTIONS, _
        ByVal pclsidHandler As Long) As Long    '

Public Declare Function AVIStreamSetFormat Lib "avifil32.dll" (ByVal pavi As Long, _
        ByVal lPos As Long, _
        ByRef lpFormat As Any, _
        ByVal cbFormat As Long) As Long

Public Declare Function AVIStreamWrite Lib "avifil32.dll" (ByVal pavi As Long, _
        ByVal lStart As Long, _
        ByVal lSamples As Long, _
        ByVal lpBuffer As Long, _
        ByVal cbBuffer As Long, _
        ByVal dwFlags As Long, _
        ByRef plSampWritten As Long, _
        ByRef plBytesWritten As Long) As Long

Public Declare Function AVIStreamReadFormat Lib "avifil32.dll" (ByVal pAVIStream As Long, _
        ByVal lPos As Long, _
        ByVal lpFormatBuf As Long, _
        ByRef sizeBuf As Long) As Long

Public Declare Function AVIStreamRead Lib "avifil32.dll" (ByVal pAVIStream As Long, _
        ByVal lStart As Long, _
        ByVal lSamples As Long, _
        ByVal lpBuffer As Long, _
        ByVal cbBuffer As Long, _
        ByRef pBytesWritten As Long, _
        ByRef pSamplesWritten As Long) As Long

Public Declare Function AVIStreamGetFrameOpen Lib "avifil32.dll" _
        (ByVal pAVIStream As Long, _
        ByRef bih As Any) As Long    'returns pointer to GETFRAME object on success (or NULL on error)

Public Declare Function AVIStreamGetFrame Lib "avifil32.dll" _
        (ByVal pGetFrameObj As Long, _
        ByVal lPos As Long) As Long    'returns pointer to packed DIB on success (or NULL on error)

Public Declare Function AVIStreamGetFrameClose Lib "avifil32.dll" _
        (ByVal pGetFrameObj As Long) As Long    ' returns zero on success (error number) after calling this function the GETFRAME object pointer is invalid


Public Declare Function AVIFileGetStream Lib "avifil32.dll" _
        (ByVal pfile As Long, _
        ByRef ppaviStream As Long, _
        ByVal fccType As Long, _
        ByVal lParam As Long) As Long

Public Declare Function AVIMakeFileFromStreams Lib "avifil32.dll" _
        (ByRef ppfile As Long, _
        ByVal nStreams As Long, _
        ByVal pAVIStreamArray As Long) As Long

Public Declare Function AVIStreamInfo Lib "avifil32.dll" _
        (ByVal pAVIStream As Long, _
        ByRef psi As AVI_STREAM_INFO, _
        ByVal lSize As Long) As Long

Public Declare Function AVIStreamStart Lib "avifil32.dll" _
        (ByVal pavi As Long) As Long

Public Declare Function AVIStreamLength Lib "avifil32.dll" _
        (ByVal pavi As Long) As Long

Public Declare Function AVIStreamRelease Lib "avifil32.dll" _
        (ByVal pavi As Long) As Long    'ULONG

Public Declare Function AVIStreamClose Lib "avifil32.dll" Alias "AVIStreamRelease" _
        (ByVal pavi As Long) As Long    'ULONG

Public Declare Function AVIFileRelease Lib "avifil32.dll" _
        (ByVal pfile As Long) As Long

Public Declare Function AVIFileClose Lib "avifil32.dll" Alias "AVIFileRelease" _
        (ByVal pfile As Long) As Long

Public Declare Sub AVIFileExit Lib "avifil32.dll" ()

'***************************************************************************
'AVI Clipboard routines
'***************************************************************************
Public Declare Function AVIMakeStreamFromClipboard Lib "avifil32.dll" _
        (ByVal cfFormat As Long, _
        ByVal hGlobal As Long, _
        ByRef ppstream As Long) As Long

Public Declare Function AVIPutFileOnClipboard Lib "avifil32.dll" _
        (ByVal pAVIFile As Long) As Long

Public Declare Function AVIGetFromClipboard Lib "avifil32.dll" _
        (ByRef ppAVIFile As Long) As Long

Public Declare Function AVIClearClipboard Lib "avifil32.dll" () As Long

'Public Declare Function GetObjectAPI Lib "gdi32.dll" Alias "GetObjectA" (ByVal hGDIObj As Long, ByVal sizBuf As Long, ByRef lpBuf As Any) As Long
'Public Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
'Public Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long 'BOOL
'Public Declare Function GetDIBits Lib "gdi32.dll" (ByVal hdc As Long, ByVal hBmp As Long, _
 '                                                    ByVal startScan As Long, ByVal numScanLines As Long, _
 '                                                    ByVal lpvBits As Long, ByRef BI As BITMAPINFOHEADER, ByVal uUsage As Long) As Long

'Public Declare Function LoadBitmapByNumber Lib "user32.dll" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpResID As Long) As Long 'hBitmap
'Public Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long 'BOOL


'**************************************************************************
' AVIFile Types
'***************************************************************************/

Private Const BMP_MAGIC_COOKIE As Integer = 19778    'this is equivalent to ascii string "BM"

Public Type BITMAPFILEHEADER '14 bytes
    bfType As Integer    '"magic cookie" - must be "BM" (19778)
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type

'//BITMAP DEFINES (from mmsystem.h)
Public Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type AVI_RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type

Public Type AVI_STREAM_INFO
    fccType As Long
    fccHandler As Long
    dwFlags As Long
    dwCaps As Long
    wPriority As Integer
    wLanguage As Integer
    dwScale As Long
    dwRate As Long
    dwStart As Long
    dwLength As Long
    dwInitialFrames As Long
    dwSuggestedBufferSize As Long
    dwQuality As Long
    dwSampleSize As Long
    rcFrame As AVI_RECT
    dwEditCount  As Long
    dwFormatChangeCount As Long
    szName As String * 64
End Type

'for use with AVIFIleInfo
Public Type AVI_FILE_INFO  '108 bytes?
    dwMaxBytesPerSecond As Long
    dwFlags As Long
    dwCaps As Long
    dwStreams As Long
    dwSuggestedBufferSize As Long
    dwWidth As Long
    dwHeight As Long
    dwScale As Long
    dwRate As Long
    dwLength As Long
    dwEditCount As Long
    szFileType As String * 64
End Type

Public Type AVI_COMPRESS_OPTIONS
    fccType As Long    '/* stream type, for consistency */
    fccHandler As Long    '/* compressor */
    dwKeyFrameEvery As Long    '/* keyframe rate */
    dwQuality As Long    '/* compress quality 0-10,000 */
    dwBytesPerSecond As Long    '/* bytes per second */
    dwFlags As Long    '/* flags... see below */
    lpFormat As Long    '/* save format */
    cbFormat As Long
    lpParms As Long    '/* compressor options */
    cbParms As Long
    dwInterleaveEvery As Long    '/* for non-video streams only */
End Type

' /**************************************************************************
' *
' *  AVIFile* Constants (converted from C defines)
' *
' ***************************************************************************/
Global Const AVIERR_OK As Long = 0&

Private Const SEVERITY_ERROR    As Long = &H80000000
Private Const FACILITY_ITF      As Long = &H40000
Private Const AVIERR_BASE       As Long = &H4000

Global Const AVIERR_BADFLAGS    As Long = SEVERITY_ERROR Or FACILITY_ITF Or (AVIERR_BASE + 105)    '-2147205015
Global Const AVIERR_BADPARAM    As Long = SEVERITY_ERROR Or FACILITY_ITF Or (AVIERR_BASE + 106)    '-2147205014
Global Const AVIERR_BADSIZE     As Long = SEVERITY_ERROR Or FACILITY_ITF Or (AVIERR_BASE + 107)    '-2147205013

Global Const AVIERR_USERABORT   As Long = SEVERITY_ERROR Or FACILITY_ITF Or (AVIERR_BASE + 198)    '-2147204922

'// Flags for dwFlags
Global Const AVIFILEINFO_HASINDEX         As Long = &H10
Global Const AVIFILEINFO_MUSTUSEINDEX     As Long = &H20
Global Const AVIFILEINFO_ISINTERLEAVED    As Long = &H100
Global Const AVIFILEINFO_WASCAPTUREFILE   As Long = &H10000
Global Const AVIFILEINFO_COPYRIGHTED      As Long = &H20000

'// Flags for dwCaps
Global Const AVIFILECAPS_CANREAD          As Long = &H1
Global Const AVIFILECAPS_CANWRITE         As Long = &H2
Global Const AVIFILECAPS_ALLKEYFRAMES     As Long = &H10
Global Const AVIFILECAPS_NOCOMPRESSION    As Long = &H20

'// Defines for the dwFlags field of the AVICOMPRESSOPTIONS struct
'// Each of these flags determines if the appropriate field in the structure
'// (dwInterleaveEvery, dwBytesPerSecond, and dwKeyFrameEvery) is payed
'// attention to.  See the autodoc in avisave.c for details.

Global Const AVICOMPRESSF_INTERLEAVE     As Long = &H1    '// interleave
Global Const AVICOMPRESSF_DATARATE       As Long = &H2    '// use a data rate
Global Const AVICOMPRESSF_KEYFRAMES      As Long = &H4    '// use keyframes
Global Const AVICOMPRESSF_VALID          As Long = &H8    '// has valid data?

Global Const OF_CANCEL = &H800
Global Const OF_CREATE = &H1000
Global Const OF_DELETE = &H200
'Const_OF_DISK = UINT(-20)
Global Const OF_EXIST = &H4000
Global Const OF_GET = &H2
Global Const OF_HANDLER = &H4
'Global Const OF_MEMORY = Const_OF_MEMORY = UINT(-6)
Global Const OF_PARSE = &H100
Global Const OF_PROMPT = &H2000
Global Const OF_READ = &H0
Global Const OF_READWRITE = &H2
Global Const OF_REOPEN = &H8000
Global Const OF_SET = &H1
Global Const OF_SHARE_COMPAT = &H0
Global Const OF_SHARE_DENY_NONE = &H40
Global Const OF_SHARE_DENY_READ = &H30
Global Const OF_SHARE_DENY_WRITE = &H20
Global Const OF_SHARE_EXCLUSIVE = &H10
Global Const OF_VERIFY = &H400
Global Const OF_WRITE = &H1



Global Const AVIIF_KEYFRAME  As Long = &H10

'/* DIB color table identifiers */
Global Const DIB_RGB_COLORS  As Long = 0    '/* color table in RGBs */
Global Const DIB_PAL_COLORS  As Long = 1    '/* color table in palette indices */

'/* constants for the biCompression field */
Global Const BI_RGB          As Long = 0
Global Const BI_RLE8         As Long = 1
Global Const BI_RLE4         As Long = 2
Global Const BI_bitfields    As Long = 3
Global Const BI_JPEG As Long = 4
Global Const BI_PNG   As Long = 5
Global Const BI_1632 As Long = &H32333631


'Stream types for use in VB (translated from C macros)
Global Const streamtypeVIDEO       As Long = 1935960438    'equivalent to: mmioStringToFOURCC("vids", 0&)
Global Const streamtypeAUDIO       As Long = 1935963489    'equivalent to: mmioStringToFOURCC("auds", 0&)
Global Const streamtypeMIDI        As Long = 1935960429    'equivalent to: mmioStringToFOURCC("mids", 0&)
Global Const streamtypeTEXT        As Long = 1937012852    'equivalent to: mmioStringToFOURCC("txts", 0&)

'// For GetFrame::SetFormat - use the best format for the display
Global Const AVIGETFRAMEF_BESTDISPLAYFMT  As Long = 1

'// defines for uiFlags (AVISaveOptions)
Global Const ICMF_CHOOSE_KEYFRAME           As Long = &H1    '// show KeyFrame Every box
Global Const ICMF_CHOOSE_DATARATE           As Long = &H2    '// show DataRate box
Global Const ICMF_CHOOSE_PREVIEW            As Long = &H4    '// allow expanded preview dialog
Global Const ICMF_CHOOSE_ALLCOMPRESSORS     As Long = &H8    '// don't only show those that

'// can handle the input format or input data
'**************************************************************************
'STANDARD WIN32 API DECLARES, UDTs and Constants
'***************************************************************************/
Private Declare Function SetRect Lib "user32.dll" _
        (ByRef lprc As AVI_RECT, _
        ByVal xLeft As Long, _
        ByVal yTop As Long, _
        ByVal xRight As Long, _
        ByVal yBottom As Long) As Long    'BOOL

Private Declare Function GetProcessHeap Lib "kernel32.dll" () As Long    'handle

Private Declare Function HeapAlloc Lib "kernel32.dll" _
        (ByVal hHeap As Long, _
        ByVal dwFlags As Long, _
        ByVal dwBytes As Long) As Long    'Pointer to mem

Private Declare Function HeapFree Lib "kernel32.dll" _
        (ByVal hHeap As Long, _
        ByVal dwFlags As Long, _
        ByVal lpMem As Long) As Long    'BOOL

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" _
        (ByRef dest As Any, _
        ByRef src As Any, _
        ByVal dwLen As Long)

Private Const HEAP_ZERO_MEMORY As Long = &H8

Global gfAbort As Boolean    'allows user to abort an AVI Save operation (see Callback function below)
Public Function AVISaveCallback(ByVal nPercent As Long) As Long 'should return C BOOL
'//Display user feedback here using nPercent

    DoEvents    'allows user to cancel
    If gfAbort = True Then
        AVISaveCallback = AVIERR_USERABORT    'abort file write
    Else
        AVISaveCallback = AVIERR_OK    'continue saving file
    End If
End Function

'**************************************************************************
'UTILITY FUNCTIONS FOR WORKING WITH AVI FILES
'***************************************************************************
Public Sub PrintAVIStreamInfo(asi As AVI_STREAM_INFO, txt As TextBox)
    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & "**** AVI_STREAM_INFO (START) *****"
    txt = txt & vbCrLf & "**********************************"
    With asi
        txt = txt & vbCrLf & "fccType = " & .fccType
        txt = txt & vbCrLf & "fccHandler = " & .fccHandler
        txt = txt & vbCrLf & "dwFlags = " & .dwFlags
        txt = txt & vbCrLf & "dwCaps = " & .dwCaps
        txt = txt & vbCrLf & "wPriority = " & .wPriority
        txt = txt & vbCrLf & "wLanguage = " & .wLanguage
        txt = txt & vbCrLf & "dwScale = " & .dwScale
        txt = txt & vbCrLf & "dwRate = " & .dwRate
        txt = txt & vbCrLf & "dwStart = " & .dwStart
        txt = txt & vbCrLf & "dwLength = " & .dwLength
        txt = txt & vbCrLf & "dwInitialFrames = " & .dwInitialFrames
        txt = txt & vbCrLf & "dwSuggestedBufferSize = " & .dwSuggestedBufferSize
        txt = txt & vbCrLf & "dwQuality = " & .dwQuality
        txt = txt & vbCrLf & "dwSampleSize = " & .dwSampleSize
        txt = txt & vbCrLf & "rcFrame.left = " & .rcFrame.left
        txt = txt & vbCrLf & "rcFrame.top = " & .rcFrame.top
        txt = txt & vbCrLf & "rcFrame.right = " & .rcFrame.right
        txt = txt & vbCrLf & "rcFrame.bottom = " & .rcFrame.bottom
        txt = txt & vbCrLf & "dwEditCount = " & .dwEditCount
        txt = txt & vbCrLf & "dwFormatChangeCount = " & .dwFormatChangeCount
        txt = txt & vbCrLf & "szName = " & .szName
    End With
    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & "**** AVI_STREAM_INFO (END) *******"
    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & ""

    If TypeOf txt Is TextBox Then
        '//No need do do anything TextBox is updated
    Else
        '//No TextBox is supplied so just dump in Immidiate window
        Debug.Print txt
    End If

End Sub

Public Sub PrintAVIFileInfo(afi As AVI_FILE_INFO, Optional txtDebug As TextBox)
    Dim txt As String

    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & "**** AVI_FILE_INFO (START) *******"
    txt = txt & vbCrLf & "**********************************"
    With afi
        txt = txt & vbCrLf & "dwMaxBytesPerSecond = " & .dwMaxBytesPerSecond
        txt = txt & vbCrLf & "dwFlags = " & .dwFlags
        txt = txt & vbCrLf & "dwCaps = " & .dwCaps
        txt = txt & vbCrLf & "dwStreams = " & .dwStreams
        txt = txt & vbCrLf & "dwSuggestedBufferSize = " & .dwSuggestedBufferSize
        txt = txt & vbCrLf & "dwWidth = " & .dwWidth
        txt = txt & vbCrLf & "dwHeight = " & .dwHeight
        txt = txt & vbCrLf & "dwScale = " & .dwScale
        txt = txt & vbCrLf & "dwRate = " & .dwRate
        txt = txt & vbCrLf & "dwLength = " & .dwLength
        txt = txt & vbCrLf & "dwEditCount = " & .dwEditCount
        txt = txt & vbCrLf & "szFileType = " & .szFileType
    End With
    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & "**** AVI_FILE_INFO (END) *********"
    txt = txt & vbCrLf & "**********************************"
    txt = txt & vbCrLf & ""

    If IsMissing(txtDebug) Then
        '//No TextBox is supplied so just dump in Immidiate window
        Debug.Print txt
    Else
        txtDebug = txt
    End If
End Sub

Public Function GetAPIErrorDesc(ErrorCode As Long) As String
    Dim Buffer As String
    Buffer = Space(200)
    FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrorCode, LANG_NEUTRAL, Buffer, 200, ByVal 0&
    GetAPIErrorDesc = Buffer
End Function
